<?php
App::uses('EvSiteSettingsAppModel', 'EvSiteSettings.Model');

class SiteSetting extends EvSiteSettingsAppModel {

/**
 * Display field
 *
 * @var string
 */
	public $displayField = 'name';

	public $order = array('SiteSetting.array_slug'=>'ASC');

	public $belongsTo = array(
		'SiteSettingCategory' => array(
			'className' => 'EvSiteSettings.SiteSettingCategory'
		)
	);

/**
 * Validation rules
 *
 * @var array
 */
	public $validate = array(
		'name' => array(
			'notEmpty' => array(
				'rule' => array('notEmpty'),
				'message' => 'A category name is required.',
				//'allowEmpty' => false,
				//'required' => false,
				//'last' => false, // Stop validation after this rule
				//'on' => 'create', // Limit validation to 'create' or 'update' operations
			),
		),
		'array_slug' => array(
			'notEmpty' => array(
				'rule' => array('notEmpty'),
				'message' => 'A slug for the settings array is requird.',
				//'allowEmpty' => false,
				//'required' => false,
				//'last' => false, // Stop validation after this rule
				//'on' => 'create', // Limit validation to 'create' or 'update' operations
			),
		),
		'type' => array(
			'notEmpty' => array(
				'rule' => array('notEmpty'),
				'message' => 'You must select a type.',
				//'allowEmpty' => false,
				//'required' => false,
				//'last' => false, // Stop validation after this rule
				//'on' => 'create', // Limit validation to 'create' or 'update' operations
			),
		),
		'site_setting_category_id' => array(
			'numeric' => array(
				'rule' => array('numeric'),
				'message' => 'You must select a category.',
				//'allowEmpty' => false,
				//'required' => false,
				//'last' => false, // Stop validation after this rule
				//'on' => 'create', // Limit validation to 'create' or 'update' operations
			),
		),
	);

	public $findMethods = array('grouped' => true);

	protected function _findGrouped($state, $query, $results = array()) {

		if ($state == 'before') {

			$query['contain'][] = 'SiteSettingCategory';

			return $query;

		} else {

			$data = array();

			foreach ($results as $result) {

				$data[$result['SiteSettingCategory']['name']][] = $result;

			}

			$results = $data;

		}

		return $results;
	}

}
